SystemOrganization addCategory: #DevPacerCommon!

ColorPresenterMorph subclass: #ColorPresenterMorphForDevPacerTaskbarItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ColorPresenterMorphForDevPacerTaskbarItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:52'!
handlesMouseDown: event
	^false! !

!ColorPresenterMorphForDevPacerTaskbarItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:54'!
mouseDown: event
	self owner mouseDown: event! !

!ColorPresenterMorphForDevPacerTaskbarItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:45'!
newHatchMorph
	"Answer a new morph showing a grid hatch pattern."

	^Morph new
		color: Color transparent;
		changeProportionalLayout;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		minWidth: 10;
		minHeight: 16;
		addMorph: (Morph new color: Color white)
		fullFrame: (LayoutFrame fractions: (0@0 corner: 0.3@1));
		addMorph: (Morph new fillStyle: (InfiniteForm with: self hatchForm))
		fullFrame: (LayoutFrame fractions: (0.3@0 corner: 0.7@1));
		addMorph: self solidLabelMorph
		fullFrame: (LayoutFrame fractions: (0.7@0 corner: 1@1));
		addMorph: self labelMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1))! !

SystemWindow subclass: #DevPacerWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacerWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:15'!
taskbarButtonFor: aTaskbar
	"Answer a new task bar button for the receiver.
	Answer nil if not required."

	^self theme
		newDevPacerTaskbarButtonIn: aTaskbar
		for: self! !

!DevPacerWindow methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/28/2012 16:51'!
taskbarButtonMenu: aMenu
	"Answer the menu for the task bar button."

	| menu theme |
	theme :=  self theme.
	menu := theme newMenuIn: self for: self.
	menu
		addToggle: 'Restore' translated
		target: self
		selector: #restore
		getStateSelector: nil
		enablementSelector: #isNotRestored.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Minimize' translated
		target: self
		selector: #minimize
		getStateSelector: nil
		enablementSelector: #isNotMinimized.
	menu lastItem
		icon: self theme windowMinimizeForm;
		font: theme menuFont.
	menu
		addToggle: 'Maximize' translated
		target: self
		selector: #maximize
		getStateSelector: nil
		enablementSelector: #canBeMaximized.
	menu lastItem
		icon: self theme windowMaximizeForm;
		font: theme menuFont.
	menu addLine.
	menu
		addToggle: 'Close' translated
		target: self
		selector: #closeBoxHit
		getStateSelector: nil
		enablementSelector: #allowedToClose.
	menu lastItem
		icon: self theme windowCloseForm;
		font: theme menuFont.
	menu add: 'Save' target: ImageSavePacer action: #buttonAction.
	^menu! !

!Morph methodsFor: '*DevPacerCommon' stamp: 'HwaJong 12/28/2012 16:22'!
openInDevPacerWindowLabeled: aString inWorld: aWorld
	"Changed to include the inset margin in the bound calculation."

	| window extent |
	window := (DevPacerWindow labelled: aString) model: nil.
	window 
		" guess at initial extent"
		bounds:  (RealEstateAgent initialFrameFor: window initialExtent: self fullBounds extent world: aWorld);
		addMorph: self frame: (0@0 extent: 1@1);
		updatePaneColors.
	" calculate extent after adding in case any size related attributes were changed.  Use
	fullBounds in order to trigger re-layout of layout morphs"
	extent := self fullBounds extent + 
			(window borderWidth@window labelHeight) + window borderWidth +
			(window class borderWidth * 2 @ (window class borderWidth + 1)). "include inset margin"
	window extent: extent.
	aWorld addMorph: window.
	window activate.
	aWorld startSteppingSubmorphsOf: window.
	^window
! !

TestCase subclass: #DevPacerTest
	instanceVariableNames: 'pacer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:28'!
setUp

	super setUp.
	pacer := DevPacer new.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:41'!
tearDown

	pacer disable.
	super tearDown.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:39'!
testDisabledAtFirst

	self deny: pacer isEnabled.
	self assert: Color gray equals: pacer stateColor.
	self assert: 'off' equals: pacer messageString.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:40'!
testEnable

	pacer enable.
	self assert: pacer isEnabled.
	self assert: Color green equals: pacer stateColor.
	self assert: 'well done!!' equals: pacer messageString.! !

!DevPacerTest methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 09:51'!
testFail

	"self fail."! !

!UITheme methodsFor: '*DevPacerCommon' stamp: 'HwaJong 12/28/2012 16:45'!
newDevPacerTaskbarButtonIn: aTaskbar for: aWindow
	"Answer a taskbar button morph for the given window."

	|lm lab button labSize c1 c2 c3 s |
	labSize := (150 // (aTaskbar tasks size + 1) max: 10) min: 30.
	lab := (self buttonLabelForText: (aWindow taskbarLabel truncateWithElipsisTo: labSize)).
	aWindow isActive
		ifTrue: [ lab emphasis: 1 "1 -> bold" ].
	lm := self
		newRowIn: aTaskbar
		for: {(aWindow taskbarIcon ifNil: [^nil]) asMorph. lab}.
	lm cellInset: 2.

	button := PluggableButtonMorph
			on: aWindow getState: #isActive action: #taskbarButtonClicked.
	button
		arguments: (#() ifNil: [{button}]);
		getEnabledSelector: nil;
		cornerStyle: (self buttonCornerStyleIn: aTaskbar);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		label: lm font: self buttonFont;
		setBalloonText: nil;
		"extent: 272 @ 30;" "extent: button minExtent;"
		"hResizing: #rigid;"
		"vResizing: #rigid"
		yourself.
	
	button  listDirection: #leftToRight.  
	

	c1 := (ColorPresenterMorphForDevPacerTaskbarItem
			on: ImageSavePacer color: #statusColor)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'this show whether time has expired or not.'.
	c1 extent: 10@10.
	button addMorphBack: c1.
	c2 := (ColorPresenterMorphForDevPacerTaskbarItem
			on: CommitPacer color: #statusColor)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'this show whether time has expired or not.'.
	c2 extent: 10@10.
	button addMorphBack: c2.
	c3 := (ColorPresenterMorphForDevPacerTaskbarItem
			on: TestPacer color: #statusColor)
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'this show whether time has expired or not.'.
	c3 extent: 10@10.
	button addMorphBack: c3.
	"s := UITheme builder newButtonFor: ImageSavePacer action: #buttonAction getEnabled: nil label: ImageSavePacer buttonLabelString help: ImageSavePacer buttonHelpString.
	button addMorphBack: s."

	button
		wantsYellowButtonMenu: true;
		getMenuSelector: #taskbarButtonMenu:;
		on: #mouseEnter send: #taskbarButtonEntered:event:in: to: aWindow withValue: button;
		on: #mouseLeave send: #taskbarButtonLeft:event:in: to: aWindow withValue: button.
	aWindow isCollapsed
		ifTrue:  [ lab color: (self taskbarButtonLabelColorForCollapsed: button) ]
		ifFalse: [ lab color: (self taskbarButtonLabelColorForExpanded: button). ].
	^button! !

Object subclass: #CommitPacer
	instanceVariableNames: ''
	classVariableNames: 'ChangeCounter NumberOfChangesTolerable'
	poolDictionaries: ''
	category: 'DevPacerCommon'!

CommitPacer class
	instanceVariableNames: 'Pacer'!

CommitPacer class
	instanceVariableNames: 'Pacer'!

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:46'!
buttonAction

	| modifiedPackages repo patches patchOperations grandPatch |
	modifiedPackages := MCPackage allInstances asSet select: [:pack| pack workingCopy modified].
		
	repo := MCCacheRepository allInstances anyOne.
	
	patches := modifiedPackages collect: [:pack| pack workingCopy changesRelativeToRepository: repo].
	
	patchOperations := OrderedCollection new.
	patches do: [:pat| patchOperations addAll: pat operations].
	grandPatch := MCPatch operations: patchOperations.
	(PSMCPatchMorph forPatch: grandPatch) openInWindowLabeled: 'Grand Patch by DevPacer'.! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:38'!
buttonHelpString

	^'open diff window. open save window'! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 13:27'!
buttonLabelString

	^'open'! !

!CommitPacer classSide methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 08:42'!
changeCounter
^ChangeCounter setDefault: #defaultChangeCounter for: self withSetter: #changeCounter:! !

!CommitPacer classSide methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 08:43'!
changeCounter: anInteger
ChangeCounter := anInteger.! !

!CommitPacer classSide methodsFor: 'defaults' stamp: 'HwaJong 11/28/2012 08:43'!
defaultChangeCounter
^0! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:09'!
defaultIntervalMinutes
	^ 15! !

!CommitPacer classSide methodsFor: 'defaults' stamp: 'HwaJong 11/28/2012 16:03'!
defaultNumberOfChangesTolerable
^50! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
getStatusText

	^self state message value! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
getStatusTextIsEnabled

	^true! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 5/16/2012 21:15'!
grayState

	^ISPState color: Color gray message: ['watching monticello is off'].! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:11'!
greenState

	^ISPState color: Color green message: ['All packages are clean.']! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:06'!
helpName

	^'commit pacer'! !

!CommitPacer classSide methodsFor: 'initialization' stamp: 'HwaJong 11/28/2012 09:19'!
initializeChangeCounter
	| repo |
	repo := MCCacheRepository allInstances anyOne.
	self changeCounter: ((Array streamContents: [:stream| ((MCPackage allInstances asSet select: [:pack| pack workingCopy modified]) collect: [:pack| pack workingCopy changesRelativeToRepository: repo]) do: [:pat| stream nextPutAll: pat operations] ]) size).! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'HwaJong 11/28/2012 12:59'!
intervalMinutes
	self pacer intervalMinutes isNil
		ifTrue: [ self pacer intervalMinutes: self defaultIntervalMinutes ].
	^self pacer intervalMinutes! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'HwaJong 11/28/2012 12:59'!
intervalMinutes: anInteger

	self pacer intervalMinutes: anInteger.! !

!CommitPacer classSide methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
isRunning

	^self pacer isRunning.! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
morphPanel
	| statusText builder colorBar checkbox button |
	builder := UITheme builder.
	colorBar := builder newColorPresenterFor: self getColor: #statusColor help: 'this show whether time has expired or not.'.
	statusText := builder newLabelFor: self getLabel: #getStatusText  getEnabled:  #getStatusTextIsEnabled.
	button := builder newButtonFor: self action: #buttonAction getEnabled: nil label: self buttonLabelString help: self buttonHelpString.
	checkbox := builder
		newCheckboxFor: self
		getSelected: #isRunning
		setSelected: #setPacerRunning:
		getEnabled: #shouldCheckboxEnabled
		label: ''
		help: 'You can turn off the ', self helpName.
	^ builder newGroupboxForAll: {builder newRow: {checkbox. builder newStack:{statusText . colorBar}. button}}.
! !

!CommitPacer classSide methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 16:04'!
numberOfChangesTolerable
^NumberOfChangesTolerable setDefault: #defaultNumberOfChangesTolerable for: self withSetter: #numberOfChangesTolerable:! !

!CommitPacer classSide methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 16:05'!
numberOfChangesTolerable: aSmallInteger 
NumberOfChangesTolerable := aSmallInteger ! !

!CommitPacer classSide methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 13:09'!
pacer

	Pacer isNil ifTrue: 
		[
			Pacer := SlimDevPacer new.
			Pacer pacerClass: self.
		].
	^Pacer.! !

!CommitPacer classSide methodsFor: 'running' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation.

	self changed: #statusColor.
	self changed: #getStatusText.
! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:05'!
redState

	^ISPState color: Color red message: ['COMMIT NOW!!!!'].    ! !

!CommitPacer classSide methodsFor: 'removing' stamp: 'HwaJong 11/28/2012 13:07'!
removePacer
Pacer := nil! !

!CommitPacer classSide methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
run

	self pacer enable.! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
setPacerRunning: aBoolean

	self perform: (aBoolean ifTrue: [ #run ] ifFalse: [ #stop ]).! !

!CommitPacer classSide methodsFor: 'system settings' stamp: 'HwaJong 11/28/2012 16:03'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Number of changer per commit' translated;
		parent: #DevPacer;
		target: #CommitPacer; 
		getSelector: #numberOfChangesTolerable;
		setSelector: #numberOfChangesTolerable:;
		domainValues: #(5 10 20 30 50 100);
		default: self defaultNumberOfChangesTolerable;
		notInStyle.! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
shouldCheckboxEnabled

	^true! !

!CommitPacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:19'!
somePackageIsDirty

	^MCWorkingCopy allManagers anySatisfy: [:wc| wc needsSaving ]  ! !

!CommitPacer classSide methodsFor: 'states' stamp: 'HwaJong 3/16/2013 18:00'!
state

	self isRunning not ifTrue: [^self grayState].
	self somePackageIsDirty ifFalse: [self changeCounter: 0].
	self changeCounter = 0 ifTrue: [^self greenState].
	(self changeCounter <= self numberOfChangesTolerable) ifTrue: [^self yellowState].
	^self redState.
! !

!CommitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 11/28/2012 12:59'!
statusColor

	^self state color.! !

!CommitPacer classSide methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
stop

	self pacer disable.
	self changed: #statusColor.
	self changed: #getStatusText.
	self changed: #isRunning.! !

!CommitPacer classSide methodsFor: 'running' stamp: 'HwaJong 11/28/2012 12:59'!
strongStop

	self stop.
	self pacer runningAni: nil.! !

!CommitPacer classSide methodsFor: 'announcements' stamp: 'HwaJong 11/28/2012 09:26'!
systemChanged: aSystemAnnouncement
"TODO: Should asked,
aSystemAnnouncement itemIsIncludedInPackage ifTrue: [ ... ]"
self changeCounter: (self changeCounter + 1)! !

!CommitPacer classSide methodsFor: 'polymorph' stamp: 'HwaJong 11/28/2012 12:58'!
taskbarIcon 

	^ThemeIcons smallJumpIcon.! !

!CommitPacer classSide methodsFor: 'states' stamp: 'HwaJong 11/28/2012 13:35'!
yellowState

	^ISPState color: Color yellow message: [self changeCounter printString, (self changeCounter > 1 ifTrue: [' changes'] ifFalse: [' change'])].! !

Object subclass: #DevPacer
	instanceVariableNames: 'dueTime runningAni intervalMinutes pacerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:08'!
countDownString

	^(self dueTime - DateAndTime now) printString copyFrom:6 to: 10.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
defaultRunningAni

	^EndlessAni new
		stepTime: 500;
		operation: (MessageSend receiver: self selector: #pacerOperation).! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:50'!
disable

	runningAni isNil ifFalse: [ runningAni stopStepping. runningAni := nil. ].! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:43'!
dueTime
	^ dueTime! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:48'!
dueTime: aDateTime
	dueTime := aDateTime! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:07'!
dueTimeHasExpired

	^self dueTime < (DateAndTime now).! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:05'!
dueTimeIsNotSet

	^self dueTime isNil.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:39'!
enable

	^self runningAni startStepping.! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 08:43'!
intervalMinutes
	^ intervalMinutes! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 6/10/2012 10:37'!
intervalMinutes: aNumber

	dueTime notNil
		ifTrue: 
			[dueTime := dueTime + (Duration minutes: aNumber-intervalMinutes)].
	intervalMinutes := aNumber.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:43'!
isEnabled

	^self runningAni isStepping.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:48'!
isRunning

	^self runningAni notNil and: [self runningAni isStepping].! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:39'!
messageString

	^self stateObject message value.! !

!DevPacer methodsFor: 'accessing' stamp: 'hjo 5/17/2012 11:24'!
pacerClass: unitPacerClass

	pacerClass := unitPacerClass.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation

	pacerClass pacerOperation.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:37'!
runningAni

	^runningAni setDefault: #defaultRunningAni for: self withSetter: #runningAni: .! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/16/2012 21:37'!
runningAni: anAni

	runningAni := anAni.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:30'!
stateColor
	^self stateObject color.! !

!DevPacer methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 08:38'!
stateObject

	self isEnabled ifFalse: [^ISPState color: Color gray message: ['off']].
	^ISPState color: Color green message: ['well done!!'].! !

Object subclass: #ISPState
	instanceVariableNames: 'message color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ISPState classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2012 17:34'!
color: aColor message: aString

	^self new
		color: aColor;
		message: aString  ! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:54'!
color

	^ color! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
color: aColor
	color := aColor! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message
	^ message! !

!ISPState methodsFor: 'accessing' stamp: 'hjo 3/26/2012 17:33'!
message: aString
	message := aString! !

Object subclass: #SlimDevPacer
	instanceVariableNames: 'runningAni pacerClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
defaultRunningAni

	^EndlessAni new
		stepTime: 500;
		operation: (MessageSend receiver: self selector: #pacerOperation).! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
disable

	runningAni isNil ifFalse: [ runningAni stopStepping. runningAni := nil. ].! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
enable

	^self runningAni startStepping.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
isEnabled

	^self runningAni isStepping.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
isRunning

	^self runningAni notNil and: [self runningAni isStepping].! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
messageString

	^self stateObject message value.! !

!SlimDevPacer methodsFor: 'accessing' stamp: 'HwaJong 11/28/2012 13:06'!
pacerClass: unitPacerClass

	pacerClass := unitPacerClass.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation

	pacerClass pacerOperation.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
runningAni

	^runningAni setDefault: #defaultRunningAni for: self withSetter: #runningAni: .! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
runningAni: anAni

	runningAni := anAni.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
stateColor
	^self stateObject color.! !

!SlimDevPacer methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/28/2012 13:06'!
stateObject

	self isEnabled ifFalse: [^ISPState color: Color gray message: ['off']].
	^ISPState color: Color green message: ['well done!!'].! !

Object subclass: #UnitPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

UnitPacer class
	instanceVariableNames: 'Pacer'!

UnitPacer class
	instanceVariableNames: 'Pacer'!

UnitPacer subclass: #ImageSavePacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'HwaJong 3/16/2013 16:56'!
buttonAction

	SmalltalkImage current saveAsNewVersionDotNumber.! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:10'!
buttonHelpString

	^'Save new image version'! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 18:58'!
buttonLabelString

	^'save'! !

!ImageSavePacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
defaultIntervalMinutes
	^ 2! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 5/16/2012 21:16'!
grayState

	^ISPState color: Color gray message: ['image monitoring is off'].! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 12:13'!
greenState

	^ISPState color: Color green message: ['No need to save image.'].    
! !

!ImageSavePacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'image pacer'! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 3/31/2012 14:12'!
redState

	^ISPState color: Color red message: ['SAVE NEW IMAGE NOW!!'].    ! !

!ImageSavePacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:10'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Image save pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #ImageSavePacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 5/17/2012 11:08'!
state

	self isRunning not ifTrue: [^self grayState].
	self pacer dueTimeIsNotSet ifTrue: [ ^self greenState ].
	self pacer dueTimeHasExpired ifTrue: [^self redState].
	^self yellowState.! !

!ImageSavePacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 11:04'!
systemChanged
	
	self pacer dueTimeIsNotSet
		ifTrue: [self pacer dueTime: DateAndTime now + (Duration minutes: self intervalMinutes)]
	! !

!ImageSavePacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 09:32'!
systemSaved

	self pacer dueTime: nil.
	self changed: #statusColor.
	self changed: #getStatusText.! !

!ImageSavePacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should save image after ', self countDownString].! !

UnitPacer subclass: #TestPacer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DevPacerCommon'!

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:09'!
buttonAction

	TestRunner open.! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:01'!
buttonHelpString

	^'open TestRunner'! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 19:00'!
buttonLabelString

	^'open'! !

!TestPacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 09:32'!
colorOfTestRunnerGotGreen

	self pacer dueTime: nil.! !

!TestPacer classSide methodsFor: 'interface' stamp: 'hjo 5/17/2012 11:08'!
colorOfTestRunnerGotNotGreen

	self pacer dueTimeIsNotSet
		ifTrue: [self pacer dueTime: DateAndTime now + (Duration minutes: self intervalMinutes)]! !

!TestPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:13'!
defaultIntervalMinutes
	^ 3! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 5/16/2012 21:16'!
grayState

	^ISPState color: Color gray message: ['TestRunner monitoring is off'].! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:38'!
greenState

	^ISPState color: Color green message: ['Test Pass'].    
! !

!TestPacer classSide methodsFor: 'gui' stamp: 'hjo 4/27/2012 19:07'!
helpName

	^'test pacer'! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/11/2012 11:40'!
redState

	^ISPState color: Color red message: ['DO ANYTHING TO MAKE IT GREEN!!'].    ! !

!TestPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:13'!
settingsItemOn: aBuilder

	<systemsettings>
	(aBuilder pickOne: #displayDepth) 
		label: 'Test pacing interval (in minutes)' translated;
		parent: #DevPacer;
		target: #TestPacer; 
		getSelector: #intervalMinutes;
		setSelector: #intervalMinutes:;
		domainValues: #(1 2 3 5 10 15);
		default: self defaultIntervalMinutes;
		notInStyle.! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 5/17/2012 11:07'!
state

	self isRunning not ifTrue: [^self grayState].
	self pacer dueTimeIsNotSet ifTrue: [ ^self greenState ].
	self pacer dueTimeHasExpired ifTrue: [^self redState].
	^self yellowState.! !

!TestPacer classSide methodsFor: 'states' stamp: 'hjo 4/20/2012 16:07'!
yellowState

	^ISPState color: Color yellow message: ['Should pass after ', self countDownString].! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 10:52'!
countDownString

	^self pacer countDownString.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:52'!
getStatusText

	^self state message value! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
getStatusTextIsEnabled

	^true! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 5/17/2012 09:25'!
intervalMinutes
	self pacer intervalMinutes isNil
		ifTrue: [ self pacer intervalMinutes: self defaultIntervalMinutes ].
	^self pacer intervalMinutes! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 6/1/2012 13:02'!
intervalMinutes: anInteger

	self pacer intervalMinutes: anInteger.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 10:48'!
isRunning

	^self pacer isRunning.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'HwaJong 12/28/2012 12:18'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'open AutoImageSave Morph')
		parent: #DevHelpers;
		order: 4;
		icon: self taskbarIcon;
		label: 'DevPacer';
		action: [ 
			| imageSavePanel commitPanel testPanel panel win |
			imageSavePanel := ImageSavePacer morphPanel.
			commitPanel := CommitPacer morphPanel.
			testPanel := TestPacer morphPanel.
			panel := UITheme builder newColumn: {imageSavePanel. commitPanel. testPanel}.
			win := panel openInDevPacerWindowLabeled: 'DevPacer' inWorld: panel currentWorld.
			win extent:   (319@152).
			win model: self ]! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 5/30/2012 18:58'!
morphPanel
	| statusText builder colorBar checkbox button |
	builder := UITheme builder.
	colorBar := builder newColorPresenterFor: self getColor: #statusColor help: 'this show whether time has expired or not.'.
	statusText := builder newLabelFor: self getLabel: #getStatusText  getEnabled:  #getStatusTextIsEnabled.
	button := builder newButtonFor: self action: #buttonAction getEnabled: nil label: self buttonLabelString help: self buttonHelpString.
	checkbox := builder
		newCheckboxFor: self
		getSelected: #isRunning
		setSelected: #setPacerRunning:
		getEnabled: #shouldCheckboxEnabled
		label: ''
		help: 'You can turn off the ', self helpName.
	^ builder newGroupboxForAll: {builder newRow: {checkbox. builder newStack:{statusText . colorBar}. button}}.
! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 5/17/2012 11:26'!
pacer

	Pacer isNil ifTrue: 
		[
			Pacer := DevPacer new.
			Pacer pacerClass: self.
		].
	^Pacer.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'HwaJong 11/28/2012 14:00'!
pacerOperation.

	self changed: #statusColor.
	self changed: #getStatusText.
! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 09:27'!
run

	self pacer enable.! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
setPacerRunning: aBoolean

	self perform: (aBoolean ifTrue: [ #run ] ifFalse: [ #stop ]).! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
shouldCheckboxEnabled

	^true! !

!UnitPacer classSide methodsFor: 'gui' stamp: 'hjo 3/31/2012 14:53'!
statusColor

	^self state color.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 10:50'!
stop

	self pacer disable.
	self changed: #statusColor.
	self changed: #getStatusText.
	self changed: #isRunning.! !

!UnitPacer classSide methodsFor: 'running' stamp: 'hjo 5/17/2012 09:28'!
strongStop

	self stop.
	self pacer runningAni: nil.! !

!UnitPacer classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/15/2012 20:05'!
taskbarIcon 

	^ThemeIcons smallJumpIcon.! !

!UnitPacer classSide methodsFor: 'system settings' stamp: 'hjo 4/11/2012 20:15'!
userStyleOn: aBuilder 
	<systemsettings>
	(aBuilder group: #DevPacer) label: 'DevPacer' translated! !
